/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-07 19:00:49 UTC)
 * on 2013-08-13 at 00:38:40 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.oauth2.model;

/**
 * Model definition for Tokeninfo.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google OAuth2 API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Tokeninfo extends com.google.api.client.json.GenericJson {

  /**
   * The access type granted with this token. It can be offline or online.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key("access_type")
  private java.lang.String accessType;

  /**
   * Who is the intended audience for this token. In general the same as issued_to.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String audience;

  /**
   * The email address of the user. Present only if the email scope is present in the request.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String email;

  /**
   * The expiry time of the token, as number of seconds left until expiry.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key("expires_in")
  private java.lang.Integer expiresIn;

  /**
   * To whom was the token issued to. In general the same as audience.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key("issued_to")
  private java.lang.String issuedTo;

  /**
   * The space separated list of scopes granted to this token.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String scope;

  /**
   * The Gaia obfuscated user id.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key("user_id")
  private java.lang.String userId;

  /**
   * Boolean flag which is true if the email address is verified. Present only if the email scope is
   * present in the request.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key("verified_email")
  private java.lang.Boolean verifiedEmail;

  /**
   * The access type granted with this token. It can be offline or online.
   * @return value or {@code null} for none
   */
  public java.lang.String getAccessType() {
    return accessType;
  }

  /**
   * The access type granted with this token. It can be offline or online.
   * @param accessType accessType or {@code null} for none
   */
  public Tokeninfo setAccessType(java.lang.String accessType) {
    this.accessType = accessType;
    return this;
  }

  /**
   * Who is the intended audience for this token. In general the same as issued_to.
   * @return value or {@code null} for none
   */
  public java.lang.String getAudience() {
    return audience;
  }

  /**
   * Who is the intended audience for this token. In general the same as issued_to.
   * @param audience audience or {@code null} for none
   */
  public Tokeninfo setAudience(java.lang.String audience) {
    this.audience = audience;
    return this;
  }

  /**
   * The email address of the user. Present only if the email scope is present in the request.
   * @return value or {@code null} for none
   */
  public java.lang.String getEmail() {
    return email;
  }

  /**
   * The email address of the user. Present only if the email scope is present in the request.
   * @param email email or {@code null} for none
   */
  public Tokeninfo setEmail(java.lang.String email) {
    this.email = email;
    return this;
  }

  /**
   * The expiry time of the token, as number of seconds left until expiry.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getExpiresIn() {
    return expiresIn;
  }

  /**
   * The expiry time of the token, as number of seconds left until expiry.
   * @param expiresIn expiresIn or {@code null} for none
   */
  public Tokeninfo setExpiresIn(java.lang.Integer expiresIn) {
    this.expiresIn = expiresIn;
    return this;
  }

  /**
   * To whom was the token issued to. In general the same as audience.
   * @return value or {@code null} for none
   */
  public java.lang.String getIssuedTo() {
    return issuedTo;
  }

  /**
   * To whom was the token issued to. In general the same as audience.
   * @param issuedTo issuedTo or {@code null} for none
   */
  public Tokeninfo setIssuedTo(java.lang.String issuedTo) {
    this.issuedTo = issuedTo;
    return this;
  }

  /**
   * The space separated list of scopes granted to this token.
   * @return value or {@code null} for none
   */
  public java.lang.String getScope() {
    return scope;
  }

  /**
   * The space separated list of scopes granted to this token.
   * @param scope scope or {@code null} for none
   */
  public Tokeninfo setScope(java.lang.String scope) {
    this.scope = scope;
    return this;
  }

  /**
   * The Gaia obfuscated user id.
   * @return value or {@code null} for none
   */
  public java.lang.String getUserId() {
    return userId;
  }

  /**
   * The Gaia obfuscated user id.
   * @param userId userId or {@code null} for none
   */
  public Tokeninfo setUserId(java.lang.String userId) {
    this.userId = userId;
    return this;
  }

  /**
   * Boolean flag which is true if the email address is verified. Present only if the email scope is
   * present in the request.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getVerifiedEmail() {
    return verifiedEmail;
  }

  /**
   * Boolean flag which is true if the email address is verified. Present only if the email scope is
   * present in the request.
   * @param verifiedEmail verifiedEmail or {@code null} for none
   */
  public Tokeninfo setVerifiedEmail(java.lang.Boolean verifiedEmail) {
    this.verifiedEmail = verifiedEmail;
    return this;
  }

  @Override
  public Tokeninfo set(String fieldName, Object value) {
    return (Tokeninfo) super.set(fieldName, value);
  }

  @Override
  public Tokeninfo clone() {
    return (Tokeninfo) super.clone();
  }

}
